#include<stdio.h>
#include<stdlib.h>
#include<iostream>
#include<stdbool.h>
#include<string.h>
#include<vector>
#include<math.h>
#include<stdint.h>
#include<ctime>
#include<assert.h>
#include<fstream>

#define test_depth 1

typedef struct board
{
	uint64_t value;
	uint64_t record;
	int step;
}board_t;

#define infinity 1000
#define infinitesimal -1000

int node_amo = 0;

std::string next_step(board_t node, bool turn); //Return the score of the path
board_t place_black(board_t node, int choice);
board_t place_white(board_t node, int choice);
int score(board_t node); //Return the score
void update(board_t& node); //Update the mark of board
void Print(board_t node); //Print the board
int place_to_num(std::string);
std::string num_to_place(int num);

//***********************************************************************************

int score(board_t node)
{
	int sco = 0;
	uint64_t val = node.value, rec = node.record;
	for (int i = 0; i < 64; i++, val = val >> 1, rec = rec >> 1)
	{
		if ((rec & 1) == 1)
		{
			switch (i)
			{
			case 0:case 7:case 56:case 63:
				(val & 1) == 1 ? sco += 8 : sco -= 8;
				break;
			case 1:case 6:case 8:case 15:case 48:case 55:case 57:case 62:
				(val & 1) == 1 ? sco++ : sco--;
				break;
			case 2:case 5:case 16:case 23:case 27:case 28:case 35:case 36:case 40:case 47:case 58:case 61:
				(val & 1) == 1 ? sco += 7 : sco -= 7;
				break;
			case 3:case 4:case 24:case 31:case 32:case 39:case 59:case 60:
				(val & 1) == 1 ? sco += 5 : sco -= 5;
				break;
			case 9:case 14:case 49:case 54:
				break;
			case 10:case 13:case 17:case 22:case 41:case 46:case 50:case 53:
				(val & 1) == 1 ? sco += 4 : sco -= 4;
				break;
			case 11:case 12:case 25:case 30:case 33:case 38:case 51:case 52:
				(val & 1) == 1 ? sco += 3 : sco -= 3;
				break;
			case 18:case 21:case 42:case 45:
				(val & 1) == 1 ? sco += 6 : sco -= 6;
				break;
			case 19:case 20:case 26:case 29:case 34:case 37:case 43:case 44:
				(val & 1) == 1 ? sco += 2 : sco -= 2;
				break;
			default:
				break;
			}

		}
	}

	return sco;
}

board_t place_black(board_t node, int choice)
{
	if(choice == 64) // Pass
		return node;

	board_t next = { node.value, node.record, node.step };

	uint64_t val = node.value >> choice, rec = node.record >> choice;
	uint64_t v, r;
	uint64_t p;

	int reverse_ind = -1;
	bool between = false;

	const int test_val[4] = { 1, 7, 8, 9 };

	for (int i = 0; i < 4; i++)
	{
		v = val >> test_val[i];
		r = rec >> test_val[i];
		if ((r & 1) == 1 && (v & 1) == 0 && (test_val[i] == 7 && choice % 8 != 0) || test_val[i] == 8 || ((test_val[i] == 1 || test_val[i] == 9) && choice % 8 != 7)) // Revised
		{
			for (int j = choice + test_val[i]; j < 64 && ((r & 1) == 1); j += test_val[i], v = v >> test_val[i], r = r >> test_val[i]) // Revised
			{
				if ((v & 1) == 0 && ((test_val[i] == 7 && j % 8 != 0) || test_val[i] == 8 || ((test_val[i] == 1 || test_val[i] == 9) && j % 8 != 7))) // Revised
					between = 1;
				else  if ((v & 1) == 1)
				{
					between ? reverse_ind = j : 0;
					break;
				}
				else
					break;
			}
			if (reverse_ind != -1)
			{
				p = pow(2, choice + test_val[i]);
				for (int j = choice + test_val[i]; j < reverse_ind; j += test_val[i], p *= pow(2, test_val[i]))
					next.value = (next.value | p);
			}
			reverse_ind = -1;
			between = 0;
		}
	}

	for (int i = 0; i < 4; i++)
	{
		v = node.value >> (choice - test_val[i]);
		r = node.record >> (choice - test_val[i]);
		if ((r & 1) == 1 && (v & 1) == 0 && (test_val[i] == 7 && choice % 8 != 7) || test_val[i] == 8 || ((test_val[i] == 1 || test_val[i] == 9) && choice % 8 != 0)) // Revised
		{
			for (int j = choice - test_val[i]; j >= 0 && ((r & 1) == 1); j -= test_val[i], v = node.value >> j, r = node.record >> j) // Revised
			{
				if ((v & 1) == 0 && ((test_val[i] == 7 && j % 8 != 7) || test_val[i] == 8 || ((test_val[i] == 1 || test_val[i] == 9) && j % 8 != 0))) // Revised
					between = 1;
				else  if ((v & 1) == 1)
				{
					between ? reverse_ind = j : 0;
					break;
				}
				else
					break;
			}
			if (reverse_ind != -1)
			{
				p = pow(2, choice - test_val[i]);
				for (int j = choice - test_val[i]; j > reverse_ind; j -= test_val[i], p /= pow(2, test_val[i]))
					next.value = (next.value | p);
			}
			reverse_ind = -1;
			between = 0;
		}
	}

	p = pow(2, choice);
	next.value = (next.value | p);
	next.record = (next.record | p);

	return next;
}

board_t place_white(board_t node, int choice)
{
	if(choice == 64) // Pass
		return node;

	board_t next = { node.value, node.record, node.step };

	uint64_t val = node.value >> choice, rec = node.record >> choice;
	uint64_t v, r;
	uint64_t p;

	int reverse_ind = -1;
	bool between = 0;

	const static int test_val[4] = { 1, 7, 8, 9 };

	for (int i = 0; i < 4; i++)
	{
		v = val >> test_val[i];
		r = rec >> test_val[i];
		if ((r & 1) == 1 && (v & 1) == 1 && (test_val[i] == 7 && choice % 8 != 0) || test_val[i] == 8 || ((test_val[i] == 1 || test_val[i] == 9) && choice % 8 != 7)) // Revised
		{
			for (int j = choice + test_val[i]; j < 64 && ((r & 1) == 1); j += test_val[i], v = v >> test_val[i], r = r >> test_val[i]) // Revised
			{
				if ((v & 1) == 1 && ((test_val[i] == 7 && j % 8 != 0) || test_val[i] == 8 || ((test_val[i] == 1 || test_val[i] == 9) && j % 8 != 7))) // Revised
					between = 1;
				else  if ((v & 1) == 0)
				{
					between ? reverse_ind = j : 0;
					break;
				}
				else
					break;
			}
			if (reverse_ind != -1)
			{
				p = pow(2, choice + test_val[i]);
				for (int j = choice + test_val[i]; j < reverse_ind; j += test_val[i], p *= pow(2, test_val[i]))
					next.value = (next.value ^ p);
			}
			reverse_ind = -1;
			between = 0;
		}
	}

	for (int i = 0; i < 4; i++)
	{
		v = node.value >> (choice - test_val[i]);
		r = node.record >> (choice - test_val[i]);
		if ((r & 1) == 1 && (v & 1) == 1 && (test_val[i] == 7 && choice % 8 != 7) || test_val[i] == 8 || ((test_val[i] == 1 || test_val[i] == 9) && choice % 8 != 0)) // Revised
		{
			for (int j = choice - test_val[i]; j >= 0 && ((r & 1) == 1); j -= test_val[i], v = node.value >> j, r = node.record >> j) // Revised
			{
				if ((v & 1) == 1 && ((test_val[i] == 7 && j % 8 != 7) || test_val[i] == 8 || ((test_val[i] == 1 || test_val[i] == 9) && j % 8 != 0))) //Revised
					between = 1;
				else  if ((v & 1) == 0)
				{
					between ? reverse_ind = j : 0;
					break;
				}
				else
					break;
			}
			if (reverse_ind != -1)
			{
				p = pow(2, choice - test_val[i]);
				for (int j = choice - test_val[i]; j > reverse_ind; j -= test_val[i], p /= pow(2, test_val[i]))
					next.value = (next.value ^ p);
			}
			reverse_ind = -1;
			between = 0;
		}
	}

	p = pow(2, choice);
	next.value = ((next.value | p) ^ p);
	next.record = (next.record | p);

	return next;
}

std::string next_step(board_t node, bool turn)
{
	std::ofstream step_record;
	step_record.open("Move_record.txt", std::ios::app);
	assert(step_record);

	update(node);

	std::vector<int> steps;

	uint64_t val = node.value, rec = node.record;
	uint64_t v, r;

	const int test_val[4] = { 1, 7, 8, 9 };

	board_t next = { node.value, node.record, node.step };

	uint64_t p;
	int reverse_ind = -1;
	bool between = 0, place = 0;
	bool pass = 1;

	uint64_t max_value = 0, max_record = 0;
	int max_score = -100, cur_score, max_step = -1;
	int cur_score_c = 0, max_score_c = infinitesimal;

	for (int i = 0; i < 64; i++, val = val >> 1, rec = rec >> 1)
	{
		if ((rec & 1) == 0 && (val & 1) == 1)
		{
			for (int k = 0; k < 4; k++)
			{
				if ((test_val[k] == 7 && i % 8 != 0) || test_val[k] == 8 || ((test_val[k] == 1 || test_val[k] == 9) && i % 8 != 7))
				{
					v = val >> test_val[k];
					r = rec >> test_val[k];
					for (int j = i + test_val[k]; j < 64 && ((r & 1) == 1); j += test_val[k], v = v >> test_val[k], r = r >> test_val[k])
					{
						if ((v & 1) == turn == 1 ? 0 : 1)
						{
							if ((test_val[k] == 7 && j % 8 == 0) || ((test_val[k] == 1 || test_val[k] == 9) && j % 8 == 7))
								break;
							between = 1;
						}
						else  if ((v & 1) == turn == 1 ? 1 : 0)
						{
							between ? reverse_ind = j : 0;
							break;
						}
					}
				}
				if (reverse_ind != -1)
				{
					printf("U%d ", test_val[k]); // Debug
					p = pow(2, i + test_val[k]);
					for (int j = i + test_val[k]; j < reverse_ind; j += test_val[k], p *= pow(2, test_val[k]))
						next.value = turn == 1 ? (next.value | p) : (next.value ^ p);
					place = 1;
				}
				reverse_ind = -1;
				between = 0;

				if ((test_val[k] == 7 && i % 8 != 7) || test_val[k] == 8 || ((test_val[k] == 1 || test_val[k] == 9) && i % 8 != 0))
				{
					v = node.value >> (i - test_val[k]);
					r = node.record >> (i - test_val[k]);
					for (int j = i - test_val[k]; j >= 0 && ((r & 1) == 1); j -= test_val[k], v = node.value >> j, r = node.record >> j)
					{
						if ((v & 1) == turn == 1 ? 0 : 1)
						{
							if ((test_val[k] == 7 && j % 8 == 7) || ((test_val[k] == 1 || test_val[k] == 9) && j % 8 == 0)) // Revised
								break;
							between = 1;
						}
						else  if ((v & 1) == turn == 1 ? 1 : 0)
						{
							between ? reverse_ind = j : 0;
							break;
						}
					}
				}
				if (reverse_ind != -1)
				{
					printf("D%d ", test_val[k]); // Debug
					p = pow(2, i - test_val[k]);
					for (int j = i - test_val[k]; j > reverse_ind; j -= test_val[k], p /= pow(2, test_val[k]))
						next.value = turn == 1 ? (next.value | p) : (next.value ^ p);
					place = 1;
				}
				reverse_ind = -1;
				between = 0;
			}

			if (place)
			{
				printf("\tAvailabe step : %d\n", i); // Debug
				pass = 0;
				place = 0;
				steps.push_back(i);
			}
		}
	}

	if (pass)
	{
		return "--";
	}

	step_record.close();

	srand(time(NULL));

	return num_to_place(steps[rand() % steps.size()]);
}

void update(board_t& node)
{
	uint64_t rec = node.record;
	uint64_t val = node.value;

	node.record = 0;
	node.value = 0;

	for (int i = 0; i < 64; i++, val = val << 1, rec = rec << 1)
	{
		node.record *= 2;
		node.value *= 2;

		if ((rec & 9223372036854775808) == 0)
		{
			i > 0 && (i % 8) != 0 && ((node.record / 2) & 1) == 1 && (node.value & 1) == 0 ? node.value++ : 0;
			i > 6 && (i % 8) != 7 && ((node.record / 128) & 1) == 1 && (node.value & 1) == 0 ? node.value++ : 0;
			i > 7 && ((node.record / 256) & 1) == 1 && (node.value & 1) == 0 ? node.value++ : 0;
			i > 8 && (i % 8) != 0 && ((node.record / 512) & 1) == 1 && (node.value & 1) == 0 ? node.value++ : 0;
		}
		else
		{
			node.record++;
			i > 0 && (i % 8) != 0 && ((node.record / 2) & 1) == 0 && ((node.value / 2) & 1) == 0 ? node.value += 2 : 0;
			i > 6 && (i % 8) != 7 && ((node.record / 128) & 1) == 0 && ((node.value / 128) & 1) == 0 ? node.value += 128 : 0;
			i > 7 && ((node.record / 256) & 1) == 0 && ((node.value / 256) & 1) == 0 ? node.value += 256 : 0;
			i > 8 && (i % 8) != 0 && ((node.record / 512) & 1) == 0 && ((node.value / 512) & 1) == 0 ? node.value += 512 : 0;
		}

		((rec & 9223372036854775808) == 9223372036854775808 && (val & 9223372036854775808) == 9223372036854775808)? node.value++ : 0;
	}
}

void Print(board_t node)
{
	printf("\n");
	printf("\n────────────────────────\n");
	uint64_t val = node.value, rec = node.record;
	for (int i = 1; i <= 64; i++, val = val << 1, rec = rec << 1)
	{
		(rec & 9223372036854775808) == 0 && (val & 9223372036854775808) == 0 ?
			printf("  |") : 0;
		(rec & 9223372036854775808) == 0 && (val & 9223372036854775808) == 9223372036854775808 ?
			printf("  |") : 0;
		(rec & 9223372036854775808) == 9223372036854775808 && (val & 9223372036854775808) == 0 ?
			printf("●|") : 0;
		(rec & 9223372036854775808) == 9223372036854775808 && (val & 9223372036854775808) == 9223372036854775808 ?
			printf("○|") : 0;

		i % 8 == 0 ? printf("\n────────────────────────\n") : 0;
	}
}

int place_to_num(std::string place)
{
	if(place == "--") //pass
		return 64;

	return 8 * (56 - (int)place[1]) + 104 - (int)place[0];
}

std::string num_to_place(int num)
{
	if(num == 64) //pass
		return "--";

	std::string place;
	switch(num % 8)
	{
	case 0:
		place.push_back('h');
		break;
	case 1:
		place.push_back('g');
		break;
	case 2:
		place.push_back('f');
		break;
	case 3:
		place.push_back('e');
		break;
	case 4:
		place.push_back('d');
		break;
	case 5:
		place.push_back('c');
		break;
	case 6:
		place.push_back('b');
		break;
	case 7:
		place.push_back('a');
		break;
	default :
		break;
	}

	switch(num / 8)
	{
	case 0:
		place.push_back('8');
		break;
	case 1:
		place.push_back('7');
		break;
	case 2:
		place.push_back('6');
		break;
	case 3:
		place.push_back('5');
		break;
	case 4:
		place.push_back('4');
		break;
	case 5:
		place.push_back('3');
		break;
	case 6:
		place.push_back('2');
		break;
	case 7:
		place.push_back('1');
		break;
	default:
		break;
	}
	return place;
}

